﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace dynaamiset
{
    public partial class Form1 : Form
    {
        List<TextBox> kentat = new List<TextBox>();
        private int tormaykset = 0;
        private int rikkinaiset = 0;
        public Form1()
        {
            InitializeComponent();
            kentat.Add(textBoxSyote);
        }

        private void buttonLisaaKentta_Click(object sender, EventArgs e)
        {
            TextBox uusiboksi = new TextBox(); 
            int x = 20 + (kentat.Count)*25;
            uusiboksi.Location = new System.Drawing.Point(110, x);
            uusiboksi.Size = new System.Drawing.Size(100, 20);
            kentat.Add(uusiboksi);
            uusiboksi.TabIndex = kentat.Count+1;
            uusiboksi.Text = (kentat.Count).ToString();
            Controls.Add(uusiboksi);
        }

        private void buttonLisää_Click(object sender, EventArgs e)
        {
            foreach (TextBox item in kentat)
            {
                item.Text = (System.Convert.ToInt16(item.Text) + 1).ToString();
            }
        }

        private void buttonLisaaAuto_Click(object sender, EventArgs e)
        {
            Auto auto = new Auto();
//            auto.tormays = new Tormays(osui);
            auto.rikki += new Rikki(rikki);
            this.Controls.Add(auto);
        }
        private void osui(int kunto, int tormayksia) {
            this.Text = kunto.ToString();
            tormaykset++;
            labelTormaykset.Text = tormaykset.ToString();
        }
        private void rikki(object sender, AutoEventArgs e)
        {
            rikkinaiset++;
            tormaykset += e.tormayksia;
            labelRikki.Text = rikkinaiset.ToString();
            labelTormaykset.Text = tormaykset.ToString();
        }


    }
    public delegate void Tormays(int kunto, int tormayksia);
    public delegate void Rikki(object sender, AutoEventArgs e);
    
    public class Auto : PictureBox {
        private int nopeus = 10;
        private System.Windows.Forms.Timer ajastin = new System.Windows.Forms.Timer();
        public Tormays tormays;
        public Rikki rikki;
        private int kunto = 10;
        private int tormayksia = 0;

        public Auto()
        {
            this.Image = global::dynaamiset.Properties.Resources.car;
            this.ParentChanged += new System.EventHandler(this.OnParentChanged);
            this.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
            this.TabStop = false;
            Random r = new Random();
            kunto = r.Next(1, 10);

            ajastin.Enabled = true;
            ajastin.Tick += new System.EventHandler(this.ajastin_Tick);
        }
// parentiin eli tässä tapauksessa lomakkeeseen voidaan viitata vasta, kun kontrolli on lisätty lomakkeelle
// eli ei vielä suoraan konstruktorissa vaan esim. ParentChanged-tapahtuman jälkeen
        private void OnParentChanged(object sender, EventArgs e)
        {
            Random r = new Random();
            this.Location = new System.Drawing.Point(r.Next(0, Parent.ClientSize.Width-ClientSize.Width), r.Next(0, Parent.ClientSize.Height-ClientSize.Height));
        }


        private void ajastin_Tick(object sender, EventArgs e)
        {
            if (kunto > 0)
            {
                int vanhanopeus = nopeus;
                if (Left <= 0) nopeus = -nopeus;
                if (Right >= Parent.ClientSize.Width) nopeus = -nopeus;
                if (vanhanopeus != nopeus)
                {
                    tormayksia++;
                    kunto--;
                    if (tormays != null) tormays(kunto, tormayksia);
                    if (rikki != null && kunto == 0) {
                        AutoEventArgs ee = new AutoEventArgs(tormayksia);
                        rikki(this, ee);
                    } 
                }
                Left = Left + nopeus;
            }
        }
    
    
    }

    public class AutoEventArgs : EventArgs 
    {
        private int tormaykset = 0;

        public int tormayksia {
            get { return tormaykset; }
            set { if ( value > 0 ) tormaykset = value; }
        }

        public AutoEventArgs(int torm = 1)
        {
            tormayksia = torm;
        }
    }

}
